      subroutine qazm(av,an,ae,azd,aihd)
c     copute azimuth from vertical, NS, and EW amplitudes.
      c1=0.0174532   
      c2=57.29578
      pi=3.141592
      az=atan2(an,ae)
      az=pi/2.-az
      if(av.gt.0.0) then
      az=az+pi
      end if
      if (az.le.0.0) az=az+2.*pi
      azd=az*c2
      azd=amod(azd,360.)
      ah=sqrt(an**2+ae**2)
      if (abs(av).gt.0.0) then
      aih=atan(ah/abs(av))
      aihd=aih*c2
      else
      aihd=90.0	
c	when av=0. and ah=0., the solution is singular
      endif
      return
      end
      subroutine latlon ( fai0d,alm0d,deltad,thetad,faid,almd)
c***** given fai0 (lat), alm0 (long),
c*****       delta, theta (azimuth clockwise from north)
c***** obtain fai (lat) and alm (long)
c***** all the angles are in degree
c***** coded jan. 7, 1986
c     implicit real*8 (a-h,o-z)
      pai = acos(0.0) * 2.0
      rad = pai / 180.0
      fai0 = fai0d * rad
      alm0 = alm0d * rad
      delta= deltad* rad
      theta= thetad* rad
      sdl  = sin (delta)
      cdl  = cos (delta)
      sf0  = sin (fai0)
      cf0  = cos (fai0)
      sth  = sin (theta)
      cth  = cos (theta)
      sf  = sf0 * cdl + cf0 * sdl * cth
      fai = asin (sf)
      cf  = cos (fai)
      sl  = (sdl*sth) / cf
      cl  = (sf*cf0 - sdl*cth) / (cf*sf0)
      alm= 0.0
      if(sl.ne.0.0 .and. cl.ne.0.0 )  alm = atan2 (sl, cl)
      faid = fai / rad
      alm = alm + alm0
      almd = alm / rad
      return
      end
      function aloga0(dist)
      parameter (c=0.49710, an=1.2178, ak=0.00530, dref=8.)
      r=sqrt(dist**2+dref**2)
      aloga0=c*r**(-an)*exp(-ak*r)
      aloga0=-alog10(aloga0)
      return
      end

      subroutine cap2lc(c,nc,index)
c     change capial to lower case(index=0) or lower case to capital
c     (index.ne.0)
      character  c*120, ic*1
      if (index.eq.0) then
      do i=1, nc
      ic=c(i:i)
      if(ichar(ic).le.90.and.ichar(ic).ge.65) then
      c(i:i)=char(ichar(ic)+32)
      end if
      end do
      else
      do i=1, nc
      ic=c(i:i)
      if(ichar(ic).le.122.and.ichar(ic).ge.97) then
      c(i:i)=char(ichar(ic)-32)
      endif
      end do
      endif
      return
      end
      
        subroutine stripbc(c1,nc1, nnbc)
c  strip leading and trailing blank characters from c1
c  nc1 # of input c1,  nnbc # of output c1
        character  c1*80
        nbb=ibcha(c1,nc1)
        c1=c1(nbb+1:nc1)
        nnbc=nbcha(c1,nc1-nbb)
        c1=c1(1:nnbc)
        return
        end
        function nbcha(c1,nc1)
c   returns the position (#) of the last non-blank character
c   nc1=# of characters in c1
        character   c1*80   
        do  k=1, nc1    
        l=nc1-k+1  
        if(c1(l:l).ne.' ') then
        lnblank=k-1
        nbcha=nc1-lnblank
        return
        end if
        end do
        end  
        function ibcha(c1,nc1)
c   returns # of leading blank characters
c   nc1=# of characters in c1
        character   c1*80   
        ibcha=0
        k=1   
300     continue
        if(c1(k:k).eq.' ') then
        ibcha=k
        k=k+1
        go to 300
        endif
        ibcha=k-1
        return
        end

      FUNCTION JULDAY(MM,ID,IYYY)
      PARAMETER (IGREG=15+31*(10+12*1582))
      IF (IYYY.EQ.0) PAUSE 'There is no Year Zero.'
      IF (IYYY.LT.0) IYYY=IYYY+1
      IF (MM.GT.2) THEN
        JY=IYYY
        JM=MM+1
      ELSE
        JY=IYYY-1
        JM=MM+13
      ENDIF
      JULDAY=INT(365.25*JY)+INT(30.6001*JM)+ID+1720995
      IF (ID+31*(MM+12*IYYY).GE.IGREG) THEN
        JA=INT(0.01*JY)
        JULDAY=JULDAY+2-JA+INT(0.25*JA)
      ENDIF
      RETURN
      END
      SUBROUTINE CALDAT(JULIAN,MM,ID,IYYY)
      PARAMETER (IGREG=2299161)
      IF(JULIAN.GE.IGREG)THEN
        JALPHA=INT(((JULIAN-1867216)-0.25)/36524.25)
        JA=JULIAN+1+JALPHA-INT(0.25*JALPHA)
      ELSE
        JA=JULIAN
      ENDIF
      JB=JA+1524
      JC=INT(6680.+((JB-2439870)-122.1)/365.25)
      JD=365*JC+INT(0.25*JC)
      JE=INT((JB-JD)/30.6001)
      ID=JB-JD-INT(30.6001*JE)
      MM=JE-1
      IF(MM.GT.12)MM=MM-12
      IYYY=JC-4715
      IF(MM.GT.2)IYYY=IYYY-1
      IF(IYYY.LE.0)IYYY=IYYY-1
      RETURN
      END
      subroutine  stdv2(x,w,n,avx,var,std1,std2)
      dimension x(*), w(*)
      sum1=0.
      sum2=0.
      sum3=0.
      do i=1, n
      sum1=sum1+x(i)*w(i)
      sum2=sum2+w(i)*x(i)**2
      sum3=sum3+w(i)
      end do
      avx=sum1/sum3
      var=(sum2/sum3)-avx**2
      std1=sqrt(var)
      std2=sqrt(var*float(n)/float(n-1))
      return
      end
      subroutine  mean2(x,w,n,avx)
      dimension x(*), w(*)
      sum1=0.
      sum3=0.
      do i=1, n
      sum1=sum1+x(i)*w(i)
      sum3=sum3+w(i)
      end do
      avx=sum1/sum3
      return
      end
